require(['config'], function() {
    require([
        'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
    ], function($) {
        pageObj.init();
    });
});

/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * const gridColModel = {}	: 화면 Grid Object			*
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 * let modifyObj = {}		: 수정화면 Object			*
 * let createObj = {}		: 신규화면 Object			*
 *******************************************************/

/*화면 변수*/
const STINFO04010_GRID_ID = '#ITP_STINFO04010_jqGrid';
const STINFO04010_GRID_LIST = '#ITP_STINFO04010_jqGrid_list';
const STINFO04010_GRID_PAGER = '#ITP_STINFO04010_jqGridPager';
const STINFO04010_GRID_EMPTY = '#ITP_STINFO04010_jqGridEmpty';

const STINFO04010_VIEW_GRID_ID = '#ITP_STINFO04010_VIEW_jqGrid';
const STINFO04010_VIEW_GRID_LIST = '#ITP_STINFO04010_VIEW_jqGrid_list';
const STINFO04010_VIEW_GRID_PAGER = '#ITP_STINFO04010_VIEW_jqGridPager';
const STINFO04010_VIEW_GRID_EMPTY = '#ITP_STINFO04010_VIEW_jqGridEmpty';

const STINFO04010_DETAIL_GRID_ID = '#ITP_STINFO04010_DETAIL_jqGrid';
const STINFO04010_DETAIL_GRID_LIST = '#ITP_STINFO04010_DETAIL_jqGrid_list';
const STINFO04010_DETAIL_GRID_PAGER = '#ITP_STINFO04010_DETAIL_jqGridPager';
const STINFO04010_DETAIL_GRID_EMPTY = '#ITP_STINFO04010_DETAIL_jqGridEmpty';

let ITP_FORM_STINFO04010_DETAIL_IS_DUPLICATE = false;
let ITP_FORM_STINFO04010_DETAIL_IS_WRITING = false;

/*API URL*/
let API_DETAIL_GRID_LIST 	= '/api/item/detail-grid-list';	    // 목록
let API_DETAIL_INFO 		= '/api/item/info-item';			// 상세
let API_DETAIL_SAVE 		= '/api/item/save-item';			// 저장
let API_ITEM_CLASS_LEVEL	= '/api/item/class-level-list';		//품목분류 level 검색

/*화면 Grid ColModel*/
const gridColModel = {
    list: [
        {
            index: 'BRAND_ID', name: 'brandId',
            label: ITP_MSG_LOCALE.label.brandId, //브랜드ID
            width: '10', fixed: false, align: 'center',
            sortable: false, hidden: true
        },
        {
            index: 'BRAND_NM', name: 'brandNm',
            label: ITP_MSG_LOCALE.label.brandNm, //브랜드명
            width: '10', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'ITEM_ID', name: 'itemId',
            label: ITP_MSG_LOCALE.label.itemId, //품목번호
            width: '10', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'ITEM_NM', name: 'itemNm',
            label: ITP_MSG_LOCALE.label.itemNm, //품목명
            width: '13', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'ITEM_TYPE_NM', name: 'itemTypeNm',
            label: ITP_MSG_LOCALE.label.itemTypeNm, //품목유형
            width: '13', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'ITEM_CLASS_NM', name: 'itemClassNm',
            label: ITP_MSG_LOCALE.label.itemClassNm, //품목분류
            width: '15', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'ST_CD', name: 'stCd',
            label: ITP_MSG_LOCALE.label.stNm, //상태
            width: '6', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'PODR_PSSBLDVSN_NM', name: 'podrPssblDvsnNm',
            label: ITP_MSG_LOCALE.label.podrPssblDvsnNm, //발주여부
            width: '6', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'UNIT', name: 'unit',
            label: ITP_MSG_LOCALE.label.unit, //기본단위
            width: '6', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'PCH_ITEM_YN', name: 'pchItemYn',
            label: ITP_MSG_LOCALE.label.pchItemYn, //구매품목여부
            width: '6', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
        {
            index: 'SALE_ITEM_YN', name: 'saleItemYn',
            label: ITP_MSG_LOCALE.label.saleItemYn, //판매품목여부
            width: '10', fixed: false, align: 'center',
            sortable: false, hidden: false
        },
    ],
    detail: [
        {
            index: 'VIEW_CD', name: 'viewCd',
            label: ITP_MSG_LOCALE.label.viewCd,
            width: '10', fixed: false, align: 'center',
            sortable: false, hidden: true
        },
        {
            index: 'AUTH_NO', name: 'authNo',
            label: ITP_MSG_LOCALE.label.permitCd,
            width: '20', fixed: false, align: 'center',
            sortable: false, editable: false, edittype: 'text',
            editrules: {required: true}
        },
        {
            index: 'AUTH_NM', name: 'authNm',
            label: ITP_MSG_LOCALE.label.permitName,
            width: '30', fixed: false, align: 'center',
            sortable: true, editable: false, edittype: 'text',
            editrules: {required: true}
        },
        {
            index: 'USE_YN_NM', name: 'useYnNm',
            label: ITP_MSG_LOCALE.label.status,
            width: '10', fixed: false, align: 'center',
            sortable: false, editable: false, edittype: 'text'
        },
        {
            index: 'ADD_DT', name: 'addDt',
            label: ITP_MSG_LOCALE.label.regDt,
            width: '10', fixed: false, align: 'center',
            sortable: false, editable: false, edittype: 'text'
        }
    ]
};

/*화면공통 Object*/
let pageObj = {
    init: function () {
        this.brandInfo = JSON.parse(sessionStorage.getItem('itp_manage_brand_info'));
        this.ui.init();
        this.event.init();
    },
    brandInfo: {},
    ui: {
        init: function () {
            this.view();
            this.grid();
            this.ready();
        },
        view: function() {
            // 버튼 권한설정
            fn_proc_btn_auth('STINFO04010');

            // 공통코드 표시
            $('select').each(function() {
                if($(this).data('select-code')) {
                    fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
                }
            });

            $('.detail_item_unit').each(function() {
                var id = $(this).attr('id');
                fn_make_select(CODE_LIST, 'DSTRBT_COST_UNIT', $(this).attr('id'));
            });

            itemClassLevel.list(1, true);
        },
        grid: function() {
            itp_fn_jqgrid_resize(STINFO04010_GRID_ID, STINFO04010_GRID_LIST, 'lg');
            listObj.empty.init();
            itp_fn_fire_window_resize();
        },
        ready: function() {
            listObj.init();
        }
    },
    event: {
        init: function () {
            this.button();
        },
        button: function () {
            // 버튼 클릭 이벤트
            $('button').each(function() {
                var id = $(this).attr('id');
                $(this).on('click', function() {
                    switch (id) {
                        case 'ITP_BTN_STINFO04010_SRH'				: listObj.button.search();		break;	// 조회 버튼 클릭
                        case 'ITP_BTN_STINFO04010_NEWREG'			: listObj.button.create(); 		break;	// 신규등록 버튼
                        case 'ITP_BTN_STINFO04010_MODIFY'			: modifyObj.button.modify();	break;	// 수정 버튼
                        case 'ITP_BTN_STINFO04010_CANCELLIST'		: createObj.button.cancel(); 	break;	// 취소/목록 버튼
                        case 'ITP_BTN_STINFO04010_DELETE'			: 								break;	// 삭제 버튼
                        case 'ITP_BTN_STINFO04010_SAVE'				: createObj.button.save(); 		break;	// 저장 버튼
                        case 'ITP_FORM_STINFO04010_DETAIL_DUP'		: createObj.button.duplicate();	break;	// 중복체크
                        case 'ITP_BTN_STINFO04010_RESET_PW'			: createObj.button.resetPass();	break;	// 상세:비밀번호 초기화
                    }
                });
            });

            $('body').on('click', function(e) {
                var gridId = STINFO04010_DETAIL_GRID_ID.replace('#', '');
                var rids = $(STINFO04010_DETAIL_GRID_ID).jqGrid('getDataIDs');
                var last_row_id = rids[rids.length - 1];
                itp_fn_grid_reset_selection(e, last_row_id, gridId, 'STINFO04010_DETAIL');
            });

        }
    },
    switchScreen: function(mode) {
        if(mode == 'LIST') { // 목록
            $('#ITP_BTN_STINFO04010_MODIFY').hide();
            $('#ITP_BTN_STINFO04010_CANCELLIST').hide();
            $('#ITP_BTN_STINFO04010_DELETE').hide();
            $('#ITP_BTN_STINFO04010_SAVE').hide();
            fn_show_btn_auth('#ITP_BTN_STINFO04010_SRH');
            fn_show_btn_auth('#ITP_BTN_STINFO04010_NEWREG');

            $('#ITP_AJAX_STINFO04010_LIST_CONTAINER').show();
            $('#ITP_AJAX_STINFO04010_DETAIL_CONTAINER').hide();
            $('#ITP_AJAX_STINFO04010_VIEW_CONTAINER').hide();
        } else if(mode == 'ADD') { // 등록
            $('#ITP_BTN_STINFO04010_SRH').hide();
            $('#ITP_BTN_STINFO04010_MODIFY').hide();
            $('#ITP_BTN_STINFO04010_NEWREG').hide();
            $('#ITP_BTN_STINFO04010_DELETE').hide();
            $('#ITP_BTN_STINFO04010_RESET_PW').hide();
            fn_show_btn_auth('#ITP_BTN_STINFO04010_CANCELLIST');
            fn_show_btn_auth('#ITP_BTN_STINFO04010_SAVE');

            $('#ITP_AJAX_STINFO04010_LIST_CONTAINER').hide();
            $('#ITP_AJAX_STINFO04010_DETAIL_CONTAINER').show();
            $('#ITP_AJAX_STINFO04010_VIEW_CONTAINER').hide();
            $('#ITP_FORM_STINFO04010_DETAIL_STORE_ID').removeAttr('readonly');
            $('#ITP_FORM_STINFO04010_DETAIL_DUP').removeAttr('disabled');

            $.each($('input, select, checkbox, radio, textarea', '#ITP_FORM_STINFO04010_DETAIL'),function(k) {
                $(this).val('');
            });

            $('#ITP_FORM_STINFO04010_DETAIL_VIEW_CD').val('C');
            $('#ITP_FORM_STINFO04010_DETAIL .fnStoreNm').text('(자동부여)');
        } else if(mode == 'MODIFY') { // 수정
            $('#ITP_BTN_STINFO04010_SRH').hide();
            $('#ITP_BTN_STINFO04010_MODIFY').hide();
            $('#ITP_BTN_STINFO04010_NEWREG').hide();
            $('#ITP_BTN_STINFO04010_DELETE').hide();
            fn_show_btn_auth('#ITP_BTN_STINFO04010_CANCELLIST');
            fn_show_btn_auth('#ITP_BTN_STINFO04010_SAVE');
            fn_show_btn_auth('#ITP_BTN_STINFO04010_RESET_PW');

            $('#ITP_AJAX_STINFO04010_LIST_CONTAINER').hide();
            $('#ITP_AJAX_STINFO04010_DETAIL_CONTAINER').show();
            $('#ITP_AJAX_STINFO04010_VIEW_CONTAINER').hide();
            $('#ITP_FORM_STINFO04010_DETAIL_STORE_ID').attr('readonly', true);
            $('#ITP_FORM_STINFO04010_DETAIL_DUP').attr('disabled', true);
            $('#ITP_FORM_STINFO04010_DETAIL_SEARCH_AFFL_SHOP_NM').attr('readonly', true);

            $('#ITP_FORM_STINFO04010_DETAIL_SEARCH_AFFL_SHOP').hide();
            $('#ITP_FORM_STINFO04010_DETAIL_DELETE_AFFL_SHOP').hide();
        } else if(mode == 'VIEW') { // 보기
            $('#ITP_BTN_STINFO04010_SRH').hide();
            $('#ITP_BTN_STINFO04010_NEWREG').hide();
            $('#ITP_BTN_STINFO04010_DELETE').hide();
            $('#ITP_BTN_STINFO04010_SAVE').hide();
            fn_show_btn_auth('#ITP_BTN_STINFO04010_MODIFY');
            fn_show_btn_auth('#ITP_BTN_STINFO04010_CANCELLIST');

            $('#ITP_AJAX_STINFO04010_LIST_CONTAINER').hide();
            $('#ITP_AJAX_STINFO04010_DETAIL_CONTAINER').hide();
            $('#ITP_AJAX_STINFO04010_VIEW_CONTAINER').show();
        }
    }
};

/*목록화면 Object*/
let listObj = {
    init: function () {
        this.form();
        this.grid.init();
    },
    itp_STINFO04010_search: false,
    button: {
        search: function() {
            listObj.itp_STINFO04010_search = true;
            let param = $('#ITP_FORM_STINFO04010_SEARCH').serializeObject();
            param.gridSize = $.jgrid.defaults.rowNum;
            param.gridPage = $.jgrid.defaults.page;
            $(STINFO04010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
        },
        create: function() {
            if(pageObj.brandInfo && pageObj.brandInfo.brandId !== '') {
                createObj.init();
            }
        }
    },
    form: function() {
        $('#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS1').on('change', function() {
            ($(this).val() === '') ? itemClassLevel.clear(2, true): itemClassLevel.list(2, true);
        });
        $('#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS2').on('change', function() {
            ($(this).val() === '') ? itemClassLevel.clear(3, true): itemClassLevel.list(3, true);
        });
        $('#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS3').on('change', function() {
            ($(this).val() === '') ? itemClassLevel.clear(4, true): itemClassLevel.list(4, true);
        });
    },
    empty: {
        init: function() {
            var _this = this;
            this.push();
            $(STINFO04010_GRID_EMPTY).on('click', function() {
                _this.back();
                _this.itp_STINFO04010_param.gridSize = $.jgrid.defaults.rowNum;
                $(STINFO04010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_STINFO04010_param)}).trigger('reloadGrid');
            });
        },
        itp_STINFO04010_param: {},
        push: function() {
            let param = $('#ITP_FORM_STINFO04010_SEARCH').serializeObject();
            listObj.itp_STINFO04010_param = param;
        },
        back: function() {
            $('#ITP_FORM_STINFO04010_SERVICE_ST_CD').val(this.itp_STINFO04010_param.sitemStCd);
            $('#ITP_FORM_STINFO04010_SEARCH_PODR_PSSBL_DVSN').val(this.itp_STINFO04010_param.spodrPssblDvsn);
            $('#ITP_FORM_STINFO04010_SEARCH_ITEM_KIND').val(this.itp_STINFO04010_param.sitemKind);
            $('#ITP_FORM_STINFO04010_SEARCH_ITEM_TYPE').val(this.itp_STINFO04010_param.sitemType);
            $('#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS1').val(this.itp_STINFO04010_param.sitemClass1);
            $('#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS2').val(this.itp_STINFO04010_param.sitemClass2);
            $('#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS3').val(this.itp_STINFO04010_param.sitemClass3);
            $('#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS4').val(this.itp_STINFO04010_param.sitemClass4);
            $('#ITP_FORM_STINFO04010_SEARCH_ITEM_NM').val(this.itp_STINFO04010_param.sitemNm);
        }
    },
    grid: {
        init: function () {
            // 데이터 없을때
            listObj.empty.push();
            this.search();
        },
        colModel: gridColModel.list,
        search: function() {
            pageObj.switchScreen('LIST');
            this.unload();
            this.load();
        },
        load: function() {
            let param = $('#ITP_FORM_STINFO04010_SEARCH').serializeObject();
            param.gridSize = $.jgrid.defaults.rowNum;
            param.sbrandId = pageObj.brandInfo.brandId;
            // param.sbrandId = sessionStorage.getItem('itp_brand_id') !== null ? sessionStorage.getItem('itp_brand_id') : 'BRD221000001';

            var option = {
                gridId: STINFO04010_GRID_ID,
                colModel: gridColModel.list,
                param: JSON.stringify(param),
                url: DOMAIN + API_DETAIL_GRID_LIST,
                pager: STINFO04010_GRID_PAGER,
                onCellSelect: function(rowId, cellIdx, cellValue) {
                    var cm = $(this).jqGrid('getGridParam', 'colModel');
                    var colNm = cm[cellIdx].name;
                    if (colNm == 'itemNm') {
                        const selectVal = $(this).jqGrid('getCell', rowId, 'itemId');
                        const key = {brandId:pageObj.brandInfo.brandId, itemId: selectVal, viewCd: 'R'};
                        var param = $.param(key);
                        viewObj.init(param);
                    }
                },
                loadComplete: function(data) {
                    console.log(data);
                    itp_fn_grid_load_complete(data, STINFO04010_GRID_ID, true, 'number', 'STINFO04010', listObj.itp_STINFO04010_search, listObj.empty, true, data.gridRecords, true);
                    var ids = $(STINFO04010_GRID_ID).getDataIDs();
                    $.each(ids, function(idx, rowId) {
                        $(STINFO04010_GRID_ID).jqGrid('setCell', rowId, 'itemNm', '', ITP_GRID_COL_STYLE.link);
                    });
                },
                onPaging: function(action) {
                    itp_fn_grid_paging(STINFO04010_GRID_ID, action, param);
                }
            };
            itp_fn_grid_make_remote(option);
        },
        clearData : function() {
            $(STINFO04010_GRID_ID).jqGrid('clearGridData', true);
            $(STINFO04010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
            $(STINFO04010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
            $(STINFO04010_GRID_EMPTY).show();
        },
        unload : function() {
            $.jgrid.gridUnload(STINFO04010_GRID_ID);
        }
    }
};

/*상세화면 Object*/
let viewObj = {
    init: function (param) {
        this.load(param);
    },
    load: function(param) {
        fn_ajax_call(API_DETAIL_INFO, param, this.callback, 'GET');
    },
    callback: function (result) {
        console.log(result);
        pageObj.switchScreen('VIEW');
        $('#ITP_FORM_STINFO04010_VIEW #ITP_FORM_STINFO04010_VIEW_ITEM_ID').val(result.itemId);
        $('#ITP_FORM_STINFO04010_VIEW .fnBrandNm').text(result.brandId);
        $('#ITP_FORM_STINFO04010_VIEW .fnStCd').text(result.itemStNm);
        $('#ITP_FORM_STINFO04010_VIEW .fnItemClass1').text(result.itemClass1);
        $('#ITP_FORM_STINFO04010_VIEW .fnItemClass2').text(result.itemClass2);
        $('#ITP_FORM_STINFO04010_VIEW .fnItemClass3').text(result.itemClass3);
        $('#ITP_FORM_STINFO04010_VIEW .fnItemClass4').text(result.itemClass4);
        $('#ITP_FORM_STINFO04010_VIEW .fnItemClassMgntNo').text(result.itemClassMgntNo);
        $('#ITP_FORM_STINFO04010_VIEW .fnItemType').text(result.itemType);
        $('#ITP_FORM_STINFO04010_VIEW .fnItemNm').text(result.itemClassNm);
        $('#ITP_FORM_STINFO04010_VIEW .fnImpDvsn').text(result.impDvsnNm);
        $('#ITP_FORM_STINFO04010_VIEW .fnPodrPssblDvsn').text(result.podrPssblDvsn);
        $('#ITP_FORM_STINFO04010_VIEW .fnUnit').text(result.unit);
        $('#ITP_FORM_STINFO04010_VIEW .fnPchItemYn').text(result.pchItemYn);
        $('#ITP_FORM_STINFO04010_VIEW .fnViewPchUnit').text(result.pchUnit);
        $('#ITP_FORM_STINFO04010_VIEW .fnSaleItemYn').text(result.saleItemYn);
        $('#ITP_FORM_STINFO04010_VIEW .fnSaleUnit').text(result.saleUnit);
        $('#ITP_FORM_STINFO04010_VIEW .fnAssetInfo').text(result.assetInfo);
        $('#ITP_FORM_STINFO04010_VIEW .fnStckUnit').text(result.stckUnit);
        $('#ITP_FORM_STINFO04010_VIEW .fnWeight').text(result.weight);
        $('#ITP_FORM_STINFO04010_VIEW .fnVolume').text(result.volume);
        $('#ITP_FORM_STINFO04010_VIEW .fnWidth').text(result.width);
        $('#ITP_FORM_STINFO04010_VIEW .fnHeight').text(result.height);
        $('#ITP_FORM_STINFO04010_VIEW .fnHigh').text(result.high);
        $('#ITP_FORM_STINFO04010_VIEW .fnOneBoxQty').text(result.oneBoxQty);
        $('#ITP_FORM_STINFO04010_VIEW .fnExpryYn').text(result.expryYn);
        $('#ITP_FORM_STINFO04010_VIEW .fnExpryDate').text(result.expryDate);
        $('#ITP_FORM_STINFO04010_VIEW .fnRtnPssblYn').text(result.rtnPssblYn);
        $('#ITP_FORM_STINFO04010_VIEW .fnRtnDvsn').text(result.rtnDvsn);
        // $('#ITP_FORM_STINFO04010_VIEW .fnItemImage').text(result.imageFileNoList);
        $.each(result.imageFileNoList, function(index, item) {
            $('#ITP_FORM_STINFO04010_VIEW .fnItemImage').append('<img src=" + item.filePath +" />');
        });
    }
};

/*수정화면 Object*/
let modifyObj = {
    init: function () {
    },
    button: {
        modify: function (param) {
            itp_fn_form_clear_validate(null, '#ITP_FORM_STINFO04010_DETAIL');
            const selectVal = $('#ITP_FORM_STINFO04010_VIEW_ITEM_ID').val();
            const key = {brandId:pageObj.brandInfo.brandId, itemId: selectVal, viewCd: 'R'};
            var param = $.param(key);
            modifyObj.load(param);
        }
    },
    load: function(param) {
        fn_ajax_call(API_DETAIL_INFO, param, this.callback, 'GET');
    },
    callback: function (result) {
        console.log(result);
        pageObj.switchScreen('MODIFY');

        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_VIEW_CD').val('U');
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_BRAND_ID').val(pageObj.brandInfo.brandId);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ITEM_ID').val(result.itemId);
        $('#ITP_FORM_STINFO04010_DETAIL .fnBrandNm').text(result.brandId);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_STORE_ST_CD').val(result.itemStCd);
        // $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ITEM_CLASS1').val(result.itemClass1);
        // $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ITEM_CLASS2').val(result.itemClass2);
        // $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ITEM_CLASS3').val(result.itemClass3);
        // $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ITEM_CLASS4').val(result.itemClass4);
        $('#ITP_FORM_STINFO04010_DETAIL .fnItemClassMgntNo').text(result.itemId);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ITEM_TYPE').val(result.itemType);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ITEM_NM').val(result.itemClassNm);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_IMP_DVSN').val(result.impDvsn);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_PODR_PSSBL_DVSN').val(result.podrPssblDvsn);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_UNIT').val(result.unit);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_PCH_ITEM_YN').val(result.pchItemYn);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_PCH_UNIT').val(result.pchUnit);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_SALE_ITEM_YN').val(result.saleItemYn);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_SALE_UNIT').val(result.saleUnit);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ASSET_INFO').val(result.assetInfo);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_STCK_UNIT').val(result.stckUnit);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_WEIGHT').val(result.weight);
        $('#ITP_FORM_STINFO04010_DETAIL .item_unit').text(result.unit);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_VOLUME').val(result.volume);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_WIDTH').val(result.width);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_HEIGHT').val(result.height);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_HIGH').val(result.high);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_ONE_BOX_QTY').val(result.oneBoxQty);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_EXPRY_YN').val(result.expryYn);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_EXPRY_DATE').val(result.expryDate);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_RTN_PSSBL_YN').val(result.rtnPssblYn);
        $('#ITP_FORM_STINFO04010_DETAIL #ITP_FORM_STINFO04010_DETAIL_RTN_DVSN').val(result.rtnDvsn);
        $.each(result.imageFileNoList, function(index, item) {
            $('#ITP_FORM_STINFO04010_VIEW .ITEM_IMAGE').append('<img src=" + item.filePath +" />');
        });

        itemClassLevel.detail.data.push(result.itemClass1);
        itemClassLevel.detail.data.push(result.itemClass2);
        itemClassLevel.detail.data.push(result.itemClass3);
        itemClassLevel.detail.data.push(result.itemClass4);
        itemClassLevel.detail.make();
    }
};

/*신규화면 Object*/
let createObj = {
    init: function () {
        pageObj.switchScreen('ADD');
        itp_fn_form_clear_validate(null, '#ITP_FORM_STINFO04010_DETAIL');
        $('#ITP_FORM_STINFO04010_DETAIL_BRAND_ID').val(pageObj.brandInfo.brandId);
        itemClassLevel.list(1, false);
    },
    button: {
        cancel: function() {
            listObj.grid.search();
        },
        save: function() {
            const formId = '#ITP_FORM_STINFO04010_DETAIL';
            itp_fn_form_clear_validate(null, formId);
            var vali_userId = itp_fn_form_validate(formId, formId + '_USER_ID', ['empty'], undefined);
            var vali_userStatCd = itp_fn_form_validate(formId, formId + '_USER_STAT_CD', ['empty'], undefined);
            var vali_userNm = itp_fn_form_validate(formId, formId + '_USER_NM', ['empty'], undefined);
            var vali_telNo = itp_fn_form_validate(formId, formId + '_TEL_NO', ['empty'], undefined);
            var vali_email = itp_fn_form_validate(formId, formId + '_EMAIL', ['empty'], undefined);
            var vali_userPw = true;
            var vali_userPwConfirm = true;
            if (vali_userId && vali_userStatCd && vali_userNm && vali_userPw && vali_userPwConfirm && vali_telNo && vali_email) {
                if (ITP_FORM_STINFO04010_DETAIL_IS_DUPLICATE) {
                    itp_fn_modal_duplicate(ITP_MSG_LOCALE.label.userId, formId + '_USER_ID');
                } else {
                    let gridInsertData = [];
                    let gridUpdateData = [];
                    let gridDeleteData = [];
                    const rowData = $(STINFO04010_DETAIL_GRID_ID).getRowData();
                    const keyValue = $(formId + '_USER_ID').val();
                    $.each(rowData, function(key, value) {
                        if (value.viewCd != 'R') {
                            value.userId = keyValue;
                            if (value.viewCd == 'C') {
                                gridInsertData.push(value);
                            } else if (value.viewCd == 'U') {
                                gridUpdateData.push(value);
                            } else if (value.viewCd == 'D') {
                                gridDeleteData.push(value);
                            }
                        }
                    });
                    let param = $(formId).serializeObject();
                    param.gridInsertData = gridInsertData;
                    param.gridUpdateData = gridUpdateData;
                    param.gridDeleteData = gridDeleteData;
                    //console.log(JSON.stringify(param));
                    var searhFn = function() {
                        ITP_FORM_STINFO04010_DETAIL_IS_WRITING = false;
                        listObj.grid.search();
                    };
                    fn_ajax_call(API_DETAIL_SAVE, JSON.stringify(param), searhFn, 'POST');
                }
            }
        }
    }
};

var itemClassLevel = {
    isList: true,
    level: 1,
    keys: function() {
        var keys = {sBrandId:pageObj.brandInfo.brandId, sItemLevel: this.level};
        for(var i=1; i<this.level; i++) {
            var key = 'sItemClass' + i;
            var id = (this.isList ? '#ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS' : '#ITP_FORM_STINFO04010_DETAIL_ITEM_CLASS') + i;
            keys[key] = $(id + ' option:selected').val();
        }
        return keys;
    },
    list: function(level, isList) {
        this.level = level;
        this.isList = isList;
        this.clear(level, isList);
        this.call( $.param(this.keys()));
    },
    detail: {
        data: [],
        make: function() {
            itemClassLevel.isList = false;
            itemClassLevel.call( $.param(itemClassLevel.keys()));
        }
    },
    call: function(param) {
        fn_ajax_call(API_ITEM_CLASS_LEVEL, param, this.callback, 'GET');
    },
    callback: function(result) {
        // console.log(result);
        var id = (itemClassLevel.isList ? 'ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS' : 'ITP_FORM_STINFO04010_DETAIL_ITEM_CLASS')  + itemClassLevel.level;
        fn_make_select_item_class(result.searchList, id, true, '선택');
        if(!itemClassLevel.isList) {
            $('#' + id).val(itemClassLevel.detail.data[ itemClassLevel.level - 1]);
            if(itemClassLevel.level < itemClassLevel.detail.data.length) {
                if(itemClassLevel.detail.data[itemClassLevel.level] !== '') {
                    itemClassLevel.level++;
                    itemClassLevel.call( $.param(itemClassLevel.keys()));
                }
            }
        }
    },
    clear: function(level, isList) {
        for(var i=level; i<5; i++) {
            var id = (isList ? 'ITP_FORM_STINFO04010_SEARCH_ITEM_CLASS' : 'ITP_FORM_STINFO04010_DETAIL_ITEM_CLASS') + i;
            $('#' + id).find('option').remove();
        }
    }
};
