require(['config'], function() {
	require([
		'jquery.bootstrap.fileUpload' //파일 업로드가 있는 페이지에서 로딩
	], function($) {
		pageObj.init();
	});
});

/********************************************************
 --------------------------------------------------------
 - Object 목록								            -
 --------------------------------------------------------
 * const gridColModel = {}	: 화면 Grid Object			*
 * let pageObj = {}			: 화면공통 Object			*
 * let listObj = {}			: 목록화면 Object			*
 * let viewObj = {}			: 상세화면 Object			*
 * let modifyObj = {}		: 수정화면 Object			*
 * let createObj = {}		: 신규화면 Object			*
 *******************************************************/

/*화면 변수*/
const STINFO06010_GRID_ID = '#ITP_STINFO06010_jqGrid';
const STINFO06010_GRID_LIST = '#ITP_STINFO06010_jqGrid_list';
const STINFO06010_GRID_PAGER = '#ITP_STINFO06010_jqGridPager';
const STINFO06010_GRID_EMPTY = '#ITP_STINFO06010_jqGridEmpty';

const STINFO06010_DETAIL_GRID_ID = '#ITP_STINFO06010_DETAIL_jqGrid';
const STINFO06010_DETAIL_GRID_LIST = '#ITP_STINFO06010_DETAIL_jqGrid_list';
const STINFO06010_DETAIL_GRID_PAGER = '#ITP_STINFO06010_DETAIL_jqGridPager';
const STINFO06010_DETAIL_GRID_EMPTY = '#ITP_STINFO06010_DETAIL_jqGridEmpty';

let STINFO06010_GRID_LAST_ROW_ID;

/*API URL*/
let API_DETAIL_GRID_LIST 	= '/api/itemunit/store-unit-grid-list';	// 목록
let API_DETAIL_INFO 		= '/api/itemunit/info-storeitemunit';		// 상세
let API_DETAIL_SAVE 		= '/api/itemunit/save-store-itemunit';		// 저장

/*화면공통 Object*/
let pageObj = {
	init: function () {
		this.brandInfo = JSON.parse(sessionStorage.getItem('itp_manage_brand_info'));
		this.ui.init();
		this.event.init();
	},
	screenMode: 'LIST',
	brandInfo: {},
	ui: {
		init: function () {
			this.view();
			this.grid();
			this.ready();
		},
		view: function() {
			// 버튼 권한설정
			fn_proc_btn_auth('STINFO06010');

			fn_make_input_common_cd(CODE_LIST, 'CURR', 'ITP_FORM_STINFO05010_DETAIL_CURR', false);
			fn_make_input_common_cd(CODE_LIST, 'UNIT_TARGET_CD', 'ITP_FORM_STINFO05010_DETAIL_UNIT_TARGET_CD', false);

			// 조회일자 지정
			$('#ITP_TAB_STINFO06010 .input-group.date').datepicker(ITP_DATE_LANGUAGE);
		},
		grid: function() {
			itp_fn_jqgrid_resize(STINFO06010_GRID_ID, STINFO06010_GRID_LIST, 'lg');
			listObj.empty.init();
			itp_fn_fire_window_resize();
		},
		ready: function() {
			listObj.init();
		}
	},
	event: {
		init: function () {
			this.button();
		},
		button: function () {
			// 버튼 클릭 이벤트
			$('button').each(function() {
				var id = $(this).attr('id');
				$(this).on('click', function() {
					switch (id) {
						case 'ITP_BTN_STINFO06010_SRH'				: (this.screenMode === 'List') ? listObj.button.search() : modifyObj.search();		break;	// 조회 버튼 클릭
						case 'ITP_BTN_STINFO06010_NEWREG'			: listObj.button.create(); 		break;	// 신규등록 버튼
						case 'ITP_BTN_STINFO06010_MODIFY'			: modifyObj.button.modify();	break;	// 수정 버튼
						case 'ITP_BTN_STINFO06010_CANCELLIST'		: listObj.grid.search(); 		break;	// 취소/목록 버튼
						case 'ITP_BTN_STINFO06010_DELETE'			: 								break;	// 삭제 버튼
						case 'ITP_BTN_STINFO06010_SAVE'				: modifyObj.button.save(); 		break;	// 저장 버튼
					}
				});
			});

		}
	},
	switchScreen: function(mode) {
		if(mode == 'LIST') { // 목록
			$('#ITP_BTN_STINFO06010_MODIFY').hide();
			$('#ITP_BTN_STINFO06010_CANCELLIST').hide();
			$('#ITP_BTN_STINFO06010_DELETE').hide();
			$('#ITP_BTN_STINFO06010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO06010_SRH');
			fn_show_btn_auth('#ITP_BTN_STINFO06010_NEWREG');

			$('#ITP_AJAX_STINFO06010_LIST_CONTAINER').show();
			$('#ITP_AJAX_STINFO06010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_STINFO06010_VIEW_CONTAINER').hide();
		} else if(mode == 'ADD') { // 등록
			$('#ITP_BTN_STINFO06010_SRH').hide();
			$('#ITP_BTN_STINFO06010_MODIFY').hide();
			$('#ITP_BTN_STINFO06010_NEWREG').hide();
			$('#ITP_BTN_STINFO06010_DELETE').hide();
			$('#ITP_BTN_STINFO06010_RESET_PW').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO06010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_STINFO06010_SAVE');

			$('#ITP_AJAX_STINFO06010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO06010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_STINFO06010_VIEW_CONTAINER').hide();
			$('#ITP_FORM_STINFO06010_DETAIL_STORE_ID').removeAttr('readonly');
			$('#ITP_FORM_STINFO06010_DETAIL_DUP').removeAttr('disabled');

			$.each($('input, select, checkbox, radio, textarea', '#ITP_FORM_STINFO06010_DETAIL'),function(k) {
				$(this).val('');
			});

			$('#ITP_FORM_STINFO06010_DETAIL_VIEW_CD').val('C');
			$('#ITP_FORM_STINFO06010_DETAIL .fnStoreNm').text('(자동부여)');
		} else if(mode == 'MODIFY') { // 수정
			$('#ITP_BTN_STINFO06010_SRH').hide();
			$('#ITP_BTN_STINFO06010_MODIFY').hide();
			$('#ITP_BTN_STINFO06010_NEWREG').hide();
			$('#ITP_BTN_STINFO06010_DELETE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO06010_CANCELLIST');
			fn_show_btn_auth('#ITP_BTN_STINFO06010_SAVE');
			fn_show_btn_auth('#ITP_BTN_STINFO06010_RESET_PW');

			$('#ITP_AJAX_STINFO06010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO06010_DETAIL_CONTAINER').show();
			$('#ITP_AJAX_STINFO06010_VIEW_CONTAINER').hide();
		} else if(mode == 'VIEW') { // 보기
			$('#ITP_BTN_STINFO06010_SRH').hide();
			$('#ITP_BTN_STINFO06010_NEWREG').hide();
			$('#ITP_BTN_STINFO06010_DELETE').hide();
			$('#ITP_BTN_STINFO06010_SAVE').hide();
			fn_show_btn_auth('#ITP_BTN_STINFO06010_MODIFY');
			fn_show_btn_auth('#ITP_BTN_STINFO06010_CANCELLIST');

			$('#ITP_AJAX_STINFO06010_LIST_CONTAINER').hide();
			$('#ITP_AJAX_STINFO06010_DETAIL_CONTAINER').hide();
			$('#ITP_AJAX_STINFO06010_VIEW_CONTAINER').show();
		}
		this.screenMode = mode;
	},
	gridColModel : {
		list: [
			{
				index: 'BRAND_ID', name: 'brandId',
				label: ITP_MSG_LOCALE.label.brandId, //브랜드ID
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'BRAND_NM', name: 'brandNm',
				label: ITP_MSG_LOCALE.label.brandNm, //브랜드명
				width: '13', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'STORE_ID', name: 'storeId',
				label: ITP_MSG_LOCALE.label.storeId, //매장ID
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'STORE_NM', name: 'storeNm',
				label: ITP_MSG_LOCALE.label.storeNm, //매장명
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: true
			},
			{
				index: 'CONT_STT_DT', name: 'contSttDt',
				label: ITP_MSG_LOCALE.label.contSttDt, //계약시작일
				width: '15', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'CONT_END_DT', name: 'contEndDt',
				label: ITP_MSG_LOCALE.label.contEndDt, //계약종료일
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'SYS_REG_DTTM', name: 'sysRegDttm',
				label: ITP_MSG_LOCALE.label.sysRegDt, //계약생성일
				width: '6', fixed: false, align: 'center',
				sortable: false, hidden: false
			},
			{
				index: 'ITEM_CNT', name: 'itemCnt',
				label: ITP_MSG_LOCALE.label.itemCnt, //계약품목수
				width: '10', fixed: false, align: 'center',
				sortable: false, hidden: false
			}
		]
	}
};

/*목록화면 Object*/
let listObj = {
	init: function () {
		this.grid.init();
	},
	itp_STINFO06010_search: false,
	button: {
		search: function() {
			listObj.itp_STINFO06010_search = true;
			let param = $('#ITP_FORM_STINFO06010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.gridPage = $.jgrid.defaults.page;
			$(STINFO06010_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
		},
		create: function() {
			if(pageObj.brandInfo && pageObj.brandInfo.brandId !== '') {
				createObj.init();
			}
		}
	},
	empty: {
		init: function() {
			var _this = this;
			this.push();
			$(STINFO06010_GRID_EMPTY).on('click', function() {
				_this.back();
				_this.itp_STINFO06010_param.gridSize = $.jgrid.defaults.rowNum;
				$(STINFO06010_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_STINFO06010_param)}).trigger('reloadGrid');
			});
		},
		itp_STINFO06010_param: {},
		push: function() {
			let param = $('#ITP_FORM_STINFO06010_SEARCH').serializeObject();
			listObj.itp_STINFO06010_param = param;
		},
		back: function() {
			$('#ITP_FORM_STINFO06010_SERVICE_ST_CD').val(this.itp_STINFO06010_param.sstorehNm);
		}
	},
	grid: {
		init: function () {
			// 데이터 없을때
			listObj.empty.push();
			this.search();
		},
		search: function() {
			pageObj.switchScreen('LIST');
			this.unload();
			this.load();
		},
		load: function() {
			let param = $('#ITP_FORM_STINFO06010_SEARCH').serializeObject();
			param.gridSize = $.jgrid.defaults.rowNum;
			param.sbrandId = pageObj.brandInfo.brandId;

			var option = {
				gridId: STINFO06010_GRID_ID,
				colModel: pageObj.gridColModel.list,
				param: JSON.stringify(param),
				url: DOMAIN + API_DETAIL_GRID_LIST,
				pager: STINFO06010_GRID_PAGER,
				onCellSelect: function(rowId, cellIdx, cellValue) {
					var cm = $(this).jqGrid('getGridParam', 'colModel');
					var colNm = cm[cellIdx].name;
					if (colNm == 'contSttDt') {
						const storeId = $(this).jqGrid('getCell', rowId, 'storeId');
						const contSttDt = $(this).jqGrid('getCell', rowId, 'contSttDt');
						const contEndDt = $(this).jqGrid('getCell', rowId, 'contEndDt');
						const key = {brandId:pageObj.brandInfo.brandId, storeId: storeId, contSttDt: contSttDt, contEndDt: contEndDt, viewCd: 'R'};
						var param = $.param(key);
						modifyObj.init(param);
					}
				},
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, STINFO06010_GRID_ID, true, 'number', 'STINFO06010', listObj.itp_STINFO06010_search, listObj.empty, true, data.gridRecords, true);
					var ids = $(STINFO06010_GRID_ID).getDataIDs();
					$.each(ids, function(idx, rowId) {
						$(STINFO06010_GRID_ID).jqGrid('setCell', rowId, 'contSttDt', '', ITP_GRID_COL_STYLE.link);
					});
				},
				onPaging: function(action) {
					itp_fn_grid_paging(STINFO06010_GRID_ID, action, param);
				}
			};
			itp_fn_grid_make_remote(option);
		},
		clearData : function() {
			$(STINFO06010_GRID_ID).jqGrid('clearGridData', true);
			$(STINFO06010_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(STINFO06010_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(STINFO06010_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(STINFO06010_GRID_ID);
		}
	}
};

/*수정화면 Object*/
let modifyObj = {
	init: function (param) {
		pageObj.switchScreen('MODIFY');
		this.grid.init(param);
	},
	itp_STINFO06010_search: false,
	search: function() {
		listObj.itp_STINFO06010_search = true;
		let param = $('#ITP_FORM_STINFO06010_DETAIL').serializeObject();
		param.gridSize = $.jgrid.defaults.rowNum;
		param.gridPage = $.jgrid.defaults.page;
		$(STINFO06010_DETAIL_GRID_ID).setGridParam({'postData': JSON.stringify(param)}).trigger('reloadGrid');
	},
	empty: {
		init: function() {
			var _this = this;
			this.push();
			$(STINFO06010_DETAIL_GRID_EMPTY).on('click', function() {
				_this.back();
				_this.itp_STINFO06010_param.gridSize = $.jgrid.defaults.rowNum;
				$(STINFO06010_DETAIL_GRID_ID).setGridParam({'postData': JSON.stringify(_this.itp_STINFO06010_param)}).trigger('reloadGrid');
			});
		},
		itp_STINFO06010_param: {},
		push: function() {
			let param = $('#ITP_FORM_STINFO06010_DETAIL').serializeObject();
			listObj.itp_STINFO06010_param = param;
		},
		back: function() {
		}
	},
	grid: {
		init: function (param) {
			// 데이터 없을때
			listObj.empty.push();
			this.unload();
			this.load(param);
		},
		load: function(param) {
			var option = {
				gridId: STINFO06010_DETAIL_GRID_ID,
				// colModel: pageObj.gridColModel.detail,
				colModel: [
					{
						index: 'BRAND_ID', name: 'brandId',
						label: ITP_MSG_LOCALE.label.brandId, //브랜드ID
						width: '10', fixed: false, align: 'center',
						sortable: false, hidden: true
					},
					{
						index: 'ITEM_ID', name: 'itemId',
						label: ITP_MSG_LOCALE.label.itemId, //품목번호
						width: '10', fixed: false, align: 'center',
						sortable: false, hidden: false
					},
					{
						index: 'ITEM_NM', name: 'itemNm',
						label: ITP_MSG_LOCALE.label.itemNm, //품목명
						width: '13', fixed: false, align: 'center',
						sortable: false, hidden: false
					},
					{
						index: 'CONT_STT_DT', name: 'contSttDt',
						label: ITP_MSG_LOCALE.label.contSttDt, //계약시작일
						width: '15', fixed: false, align: 'center',
						sortable: false, hidden: false
					},
					{
						index: 'CONT_END_DT', name: 'contEndDt',
						label: ITP_MSG_LOCALE.label.contEndDt, //계약종료일
						width: '6', fixed: false, align: 'center',
						sortable: false, hidden: false
					},
					{
						index: 'UNIT', name: 'unit',
						label: ITP_MSG_LOCALE.label.unit, //기본단위
						width: '6', fixed: false, align: 'center',
						sortable: true, editable: true, edittype: 'text',
						editrules: {required: true}
					},
					{
						index: 'STDD_QYT', name: 'stddQty',
						label: ITP_MSG_LOCALE.label.stddQty, //기준수량
						width: '6', fixed: false, align: 'center',
						sortable: true, editable: true, edittype: 'text',
						editrules: {required: true}
					},
					{
						index: 'CURR', name: 'curr',
						label: ITP_MSG_LOCALE.label.curr, //통화
						width: '10', fixed: false, align: 'center',
						sortable: false, editable: true, formatter: 'select', edittype: 'select',
						editoptions: {value: $('#ITP_FORM_STINFO05010_DETAIL_CURR').val()},
						editrules: {required: true}
					},
					{
						index: 'UNIT_AMT', name: 'unitAmt',
						label: ITP_MSG_LOCALE.label.unitAmt, //단가
						width: '10', fixed: false, align: 'center',
						sortable: true, editable: true, edittype: 'text',
						editrules: {required: true}
					},
					{
						index: 'UNIT_TARGET_CD', name: 'unitTargetCd',
						label: ITP_MSG_LOCALE.label.unitTargetCd, //대상여부
						width: '6', fixed: false, align: 'center',
						sortable: false, editable: true, formatter: 'select', edittype: 'select',
						editoptions: {value: $('#ITP_FORM_STINFO05010_DETAIL_UNIT_TARGET_CD').val()},
						editrules: {required: true}
					},
					{
						index: 'SPPLY_UNIT_AMT', name: 'spplyUnitAmt',
						label: ITP_MSG_LOCALE.label.spplyUnitAmt, //공급단가
						width: '6', fixed: false, align: 'center',
						sortable: false, hidden: false
					}
				],
				mtype: 'GET',
				param: param,
				url: DOMAIN + API_DETAIL_INFO,
				loadComplete: function(data) {
					console.log(data);
					itp_fn_grid_load_complete(data, STINFO06010_DETAIL_GRID_ID, false, 'number', 'STINFO06010', modifyObj.itp_STINFO06010_search, modifyObj.empty, true, data.gridRecords, true);
				},
				onCellSelect: function(rowId, cellIdx, cellValue) {
					STINFO06010_GRID_LAST_ROW_ID = itp_fn_set_data_editable(rowId, cellIdx, STINFO06010_GRID_LAST_ROW_ID, STINFO06010_DETAIL_GRID_ID, ['itemId']);
				},
				onPaging: function(action) {
					itp_fn_grid_paging(STINFO06010_GRID_ID, action, param);
				}
			};
			itp_fn_grid_make_remote(option);
		},
		clearData : function() {
			$(STINFO06010_DETAIL_GRID_ID).jqGrid('clearGridData', true);
			$(STINFO06010_DETAIL_GRID_LIST).find('.ui-jqgrid-bdiv').css('min-height', '100px');
			$(STINFO06010_DETAIL_GRID_EMPTY).html(ITP_MSG_LOCALE.message.grid.noData);
			$(STINFO06010_DETAIL_GRID_EMPTY).show();
		},
		unload : function() {
			$.jgrid.gridUnload(STINFO06010_DETAIL_GRID_ID);
		}
	}
};
